package provide odbc::wrap 1.1
package require odbc::obj
namespace eval odbc {}
variable ::odbc::wrap_seq 0
namespace eval ::odbc::wrapped {}
proc ::odbc::wrap_tclodbc_database args {
    # Creating my private object 
    switch -exact -- [lindex $args 0] {
	datasources -
	drivers 
	{
	    return [eval [linsert $args 0 ::odbc::database]]
	}
    }
    set myobj [uplevel 1 [linsert $args 0 ::odbc::database]]
    rename $myobj [set newname ::odbc::wrapped::[incr ::odbc::wrap_seq]]
    interp alias {} $myobj {} ::odbc::wrap_tclodbc_instance $newname
    trace add command $newname delete "[list rename $myobj {}];#"
    return $myobj
}
proc ::odbc::wrap_tclodbc_instance {oobj args} {
    set mtd [lindex $args 0]
    if {![llength [$oobj info methods $mtd]]} {
	uplevel 1 [linsert $args 0 $oobj run]
    } else {
	uplevel 1 [linsert $args 0 $oobj]
    }
}
namespace eval ::odbc { namespace export wrap_tclodbc_database }
